var ClosedTabsClick2Tab =
{
    closedTabs : [],
    cmdLastClosedTab : null,

    push : function (sessionHistory)
    {
        this.closedTabs.push([sessionHistory]);
        this.cmdLastClosedTab.removeAttribute("disabled");
        if (this.closedTabs.length > gBrowser.mPrefs.getIntPref(prefStringClick2TabClosedCacheSize))
            this.closedTabs.shift();
    },

    removeTab : function (index)
    {
        this.closedTabs.splice(index, 1);
        if (!this.closedTabs.length)
            this.cmdLastClosedTab.setAttribute("disabled", "true");
    },

    clearAllTabs : function()
    {
        this.closedTabs.splice(0, this.closedTabs.length);
        this.cmdLastClosedTab.setAttribute("disabled", "true");
    }
};

var TabbrowserClick2Tab =
{
    init : function()
    {
        gBrowser.__removeTab = gBrowser.removeTab;
        gBrowser.removeTab = this.removeTab;
        
        __BrowserCloseTabOrWindow = BrowserCloseTabOrWindow;
        BrowserCloseTabOrWindow = this.BrowserCloseTabOrWindow;
        
        ClosedTabsClick2Tab.cmdLastClosedTab = document.getElementById("cmd_undoLastClosedTab");
    },

    deinit : function()
    {
        gBrowser.removeTab = gBrowser.__removeTab;
        BrowserCloseTabOrWindow = __BrowserCloseTabOrWindow;
    },

    blankTab : function (webNavigation)
    {
        if (webNavigation.sessionHistory.count == 0)
            return true;
        if (webNavigation.sessionHistory.count == 1 && (webNavigation.currentURI.spec == "about:blank"))
        {
            webNavigation.sessionHistory.PurgeHistory(webNavigation.sessionHistory.count);
            return true;
        }
        return false;
    },

    removeTab : function (aTab)
    {
        if (aTab.localName != "tab")
            aTab = this.mCurrentTab;

        var l = this.mTabContainer.childNodes.length;
        if (l == 1) {
            if (!this.mPrefs.getBoolPref("browser.tabs.autoHide")) {
                // Clear the session history of the last tab, added by NetOne on 2004/11/16
                if (this.mPrefs.getBoolPref(prefStringClick2TabClearHistory)
                    && !TabbrowserClick2Tab.blankTab(this.webNavigation))
                {
                    // Push the session history for undo closed tabs, added by NetOne on 2004/12/12
                    ClosedTabsClick2Tab.push(this.sessionHistory);
                    // webNavigation must be used since sessionHistory is a readonly property of gBrowser
                    this.webNavigation.sessionHistory = 
                        Components.classes["@mozilla.org/browser/shistory;1"]
                                  .createInstance(Components.interfaces.nsISHistory);
                }

                // blank the tab
                this.loadURI("about:blank");
                return;
            }
            // hide the tab bar
            this.mPrefs.setBoolPref("browser.tabs.forceHide", true);
            this.setStripVisibilityTo(false);
            return;
        }

        var ds = this.getBrowserForTab(aTab).docShell;

        if (ds.contentViewer && !ds.contentViewer.permitUnload())
            return;

        if (l == 2) {
            var autohide = this.mPrefs.getBoolPref("browser.tabs.autoHide");
            if (autohide)
                this.setStripVisibilityTo(false);
        }

        var index = -1;
        if (this.mCurrentTab == aTab)
            index = this.mPanelContainer.selectedIndex;
        else {
            // Find and locate the tab in our list.
            for (var i = 0; i < l; i++)
                if (this.mTabContainer.childNodes[i] == aTab)
            index = i;
        }

        // Remove the tab's filter and progress listener.
        const filter = this.mTabFilters[index];
        var oldBrowser = this.getBrowserAtIndex(index);
        oldBrowser.webProgress.removeProgressListener(filter);
        filter.removeProgressListener(this.mTabListeners[index]);
        this.mTabFilters.splice(index, 1);
        this.mTabListeners.splice(index, 1);

        // Remove our title change and blocking listeners
        oldBrowser.removeEventListener("DOMTitleChanged", this.onTitleChanged, false);

        // We are no longer the primary content area.
        oldBrowser.setAttribute("type", "content");

        // Now select the new tab before nuking the old one.
        var currentIndex = this.mPanelContainer.selectedIndex;

        var newIndex = -1;
        if (currentIndex > index)
            newIndex = currentIndex-1;
        else if (currentIndex < index)
            newIndex = currentIndex;
        else if (index == l - 1)
            newIndex = index-1;
        else
            newIndex = index;

        // Push the session history for undo closed tabs, added by NetOne on 2004/12/12
        if (!TabbrowserClick2Tab.blankTab(oldBrowser.webNavigation))
            ClosedTabsClick2Tab.push(this.sessionHistory);

        var oldTab = aTab;

        // clean up the before/afterselected attributes before removing the tab
        oldTab.selected = false;

        // XXX browser's destructor isn't always called, so we force a cleanup ourselves
        oldBrowser.destroy();

        this.mTabContainer.removeChild(oldTab);
        this.mPanelContainer.removeChild(this.mPanelContainer.childNodes[index]);

        this.selectedTab = this.mTabContainer.childNodes[newIndex];
        this.mPanelContainer.selectedIndex = newIndex;

        this.updateCurrentBrowser();
    },

    undoClosedTab : function (closedTabsIndex)
    {
        if (!ClosedTabsClick2Tab.closedTabs.length)
            return;

        var oldHistory = ClosedTabsClick2Tab.closedTabs[closedTabsIndex][0];
        ClosedTabsClick2Tab.removeTab(closedTabsIndex);

        var aTab, aBrowser;
        if (!this.blankTab(gBrowser.webNavigation))
        {
            aTab = gBrowser.addTab("about:blank");
            if (gBrowser.mPrefs.getBoolPref(prefStringClick2TabReopenInBackground))
                aBrowser = gBrowser.getBrowserForTab(aTab);
            else
            {
                gBrowser.selectedTab = aTab;
                aBrowser = gBrowser.mCurrentBrowser;
            }
        }
        else
            aBrowser = gBrowser.mCurrentBrowser;

        var newHistory = aBrowser.sessionHistory;
        newHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
        for (var i = 0; i < oldHistory.count; i++)
        {
            newHistory.addEntry(oldHistory.getEntryAtIndex(i, false), true);
        }
        if (oldHistory.count)
            aBrowser.webNavigation.gotoIndex(oldHistory.index);
    },

    undoLastClosedTab : function()
    {
        this.undoClosedTab(ClosedTabsClick2Tab.closedTabs.length - 1);
    },

    buildClosedTabList : function (popup)
    {
        var menuItem;
        while (popup.hasChildNodes())
            popup.removeChild(popup.lastChild);

        for (var i = ClosedTabsClick2Tab.closedTabs.length; i > 0; )
        {
            var tabHistory = ClosedTabsClick2Tab.closedTabs[--i][0];
            menuItem = document.createElement("menuitem");
            var title = tabHistory.getEntryAtIndex(tabHistory.index, false).title;
            var uri = tabHistory.getEntryAtIndex(tabHistory.index, false).URI.spec;
            
            menuItem.setAttribute("label", title || uri);
            menuItem.setAttribute("tooltiptext", title ? uri : "");
            menuItem.closedTabsIndex = i;
            popup.appendChild(menuItem);
        }

        popup.appendChild(document.createElement("menuseparator"));

        menuItem = document.createElement("menuitem");
        var stringBundle = document.getElementById("click2tabStrings");
        menuItem.setAttribute("label", stringBundle.getString("click2tab.clearAllClosedTabs"));
        menuItem.setAttribute("oncommand", "ClosedTabsClick2Tab.clearAllTabs(); event.preventBubble();");
        popup.appendChild(menuItem);
    },

    BrowserCloseTabOrWindow : function ()
    {
        // Code changed by Netone to allow Close+W only close the tab, on 12/11/2004
        if (gBrowser.localName == 'tabbrowser'
            && ((gBrowser.tabContainer.childNodes.length > 1)
                 || gBrowser.mPrefs.getBoolPref(prefStringClick2TabCtlWCloseTab))) {
            // Just close up a tab.
            gBrowser.removeCurrentTab();
            return;
        }

        BrowserCloseWindow();
    }
};
